routes/web.php
<?php

use App\Http\Controllers\AssignTaskController;
use App\Http\Controllers\ChangePasswordController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\GrantNewTokenController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\ProjectController;
use App\Http\Controllers\RequestTokenController;
use App\Http\Controllers\TaskController;
use App\Http\Controllers\TrashedClientController;
use App\Http\Controllers\TrashedProjectController;
use App\Http\Controllers\TrashedTaskController;
use App\Http\Controllers\TrashedUserController;
use App\Http\Controllers\UnassignTaskController;
use App\Http\Controllers\UpdatePasswordController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;
use Symfony\Component\HttpKernel\Profiler\Profile;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes(['register' => false]);

Route::redirect('/', 'login');

Route::middleware(['guest'])->group(function() {
    Route::controller(ChangePasswordController::class)->prefix('/change-password')->group(function () {
        Route::get('/{token}', 'create')->name('change-password.create');
        Route::post('/', 'store')->name('change-password.store');
    });

    Route::controller(RequestTokenController::class)->prefix('/request-token')->group(function () {
        Route::get('/{token}', 'create')->name('request-token.create');
        Route::post('/', 'store')->name('request-token.store');
    });
});


Route::middleware(['auth', 'password_not_changed'])->group(function (){
    Route::get('/dashboard', DashboardController::class)->name('dashboard');
    Route::post('/new_password', [UpdatePasswordController::class, 'store'])->name('new-password.store');

    Route::controller(ProfileController::class)->prefix('/profiles/{user}')->group(function (){
        Route::get('/', 'show')->name('profiles.show');
        Route::get('/edit', 'edit')->name('profiles.edit');
        Route::put('/', 'update')->name('profiles.update');
    });

    Route::resource('users', UserController::class);
    Route::patch('/users/{user}/restore', [UserController::class, 'restore'])->withTrashed()->name('users.restore');
    Route::post('users/{user}/token', GrantNewTokenController::class)->name('users.new-token');

    Route::resource('clients', ClientController::class);
    Route::patch('/clients/{client}/restore', [ClientController::class, 'restore'])->withTrashed()->name('clients.restore');
    Route::patch('/clients/{client}/forcedelete', [ClientController::class, 'forceDelete'])->withTrashed()->name('clients.force-delete');
    
    Route::resource('projects', ProjectController::class);
    Route::patch('/projects/{project}/restore', [ProjectController::class, 'restore'])->withTrashed()->name('projects.restore');
    Route::patch('/projects/{project}/forcedelete', [ProjectController::class, 'forceDelete'])->withTrashed()->name('projects.force-delete');

    Route::resource('tasks', TaskController::class);
    Route::patch('/tasks/{task}/restore', [TaskController::class, 'restore'])->withTrashed()->name('tasks.restore');
    Route::patch('/tasks/{task}/forcedelete', [TaskController::class, 'forceDelete'])->withTrashed()->name('tasks.force-delete');
    Route::patch('/tasks/{task}/unassign', UnassignTaskController::class)->name('tasks.unassign');
    Route::patch('/tasks/{task}/assign', AssignTaskController::class)->name('tasks.self-assign');

    Route::get('/trashed/projects', TrashedProjectController::class)->name('projects.trashed');
    Route::get('/trashed/clients', TrashedClientController::class)->name('clients.trashed');
    Route::get('/trashed/tasks', TrashedTaskController::class)->name('tasks.trashed');
    Route::get('/trashed/users', TrashedUserController::class)->name('users.trashed');
});

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Relations\HasMany;
use Laravel\Sanctum\HasApiTokens;
use Illuminate\Notifications\Notifiable;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Spatie\MediaLibrary\HasMedia;
use Spatie\MediaLibrary\InteractsWithMedia;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable implements HasMedia
{
    use HasApiTokens, HasFactory, Notifiable, SoftDeletes, HasRoles, InteractsWithMedia;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'token',
        'password_changed_at',
        'new_token_requested_at',
        'token_reset_at',
        'token_expires_at',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
        'password_changed_at',
        'deleted_at',
        'email_verified_at',
        'new_token_requested_at',
        'token_reset_at',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password_changed_at' => 'datetime',
        'new_token_requested_at' => 'datetime',
        'token_expires_at' => 'datetime',
    ];

    public static function boot()
    {
        parent::boot();

        static::deleting( function(User $user) {
            $user->tasks()->each(function ($task) {
                $task->user_id = null;
                $task->save();
            });

            $user->projects()->each(function ($project) {
                $project->manager_id = null;
                $project->save();
            });
        });
    }

    public function projects(): HasMany
    {
        return $this->hasMany(Project::class, 'manager_id');
    }

    public function tasks(): HasMany
    {
        return $this->hasMany(Task::class)->latest();
    }

    public function getIsTokenExpiredAttribute(): bool
    {
        return !empty($this->token_expires_at) && $this->token_expires_at < now();
    }

    public function getHasRequestedNewTokenAttribute(): bool
    {
        return $this->new_token_requested_at != null;
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Models\User;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use App\Http\Requests\UserRequest;
use App\Mail\AccountCreated;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Str;
use Illuminate\View\View;
use Spatie\Permission\Models\Role;

class UserController extends Controller
{
    public function __construct()
    {
        $this->authorizeResource(User::class, 'user');
    }

    public function index(): View
    {
        $builder = User::query();

        if ($search = request()->get('search')) {
           $builder->where('name', 'LIKE', '%'.$search.'%')
            ->orWhere('email', 'LIKE', '%'.$search.'%');
        }

        $users = $builder->with('roles')->paginate(10);

        return view('users.index', compact('users', 'search'));
    }

    public function create(): View
    {
        if (auth()->user()->hasRole('super-admin')) {
            $roles = Role::all();
        } else {
            $roles = Role::whereIn('name', ['employee', 'manager'])->get();
        }

        return view('users.create', compact('roles'));
    }

    public function store(UserRequest $request): RedirectResponse
    {
        $user = User::make($request->only(['name', 'email']));
        $user['password'] = Hash::make(Str::random(18));
        $user['token'] = Str::random(40);
        $user['token_expires_at'] = now()->addDays(3);
        $user->save();

        if($request->role_id == null) {
            $user->assignRole('employee');
        }

        $user->assignRole($request->role_id);

        Mail::to($user)->queue(new AccountCreated($user['token'], $user['name']));

        return redirect()->route('users.index')
            ->with('success', 'A new user account has been created.');
    }

    public function show(User $user): View
    {
        if ($user->is_token_expired) {
            dump($user->token_expires_at);
        }

        $user->load('roles');

        return view('users.show', compact('user'));
    }

    public function edit(User $user): View
    {
        if($user->hasRole('super-admin') && !auth()->user()->hasRole('super-admin')) {
            abort(403, 'You are not authorized to perform this action');
        }

        if(auth()->user()->hasRole('super-admin')) {
            $roles = Role::all();
        } else {
            $roles = Role::whereIn('name', ['manager', 'employee'])->get();
        }

        return view('users.edit', compact(['user', 'roles']));
    }

    public function update(UserRequest $request, User $user): RedirectResponse
    {
        $user->update($request->only(['name', 'email']));

        $user->syncRoles($request->role_id);

        return redirect()->route('users.index')
            ->with('success', 'The user account has been updated.');
    }

    public function destroy(User $user): RedirectResponse
    {
        if($user->hasRole('super-admin') && !auth()->user()->hasRole('super-admin')) {
            abort(403, 'You are not authorized to perform this action');
        }

        $user->delete();

        return redirect()->route('users.index')
            ->with('success','The user account has been deleted.');
    }

    public function restore(User $user): RedirectResponse
    {
        $this->authorize('restore', $user);

        $user->restore();

        return redirect()->route('users.trashed')
            ->with('success', 'The user has been restored.');
    }
}

resources/views/users/create.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">
                    <h1 class="card-title text-capitalize">New User</h1>
                </div>

                <div class="card-body">
                    <x-errors :errors="$errors"/>

                    <form action="{{ route('users.store') }}" method="POST">
                        @csrf

                        <form action="{{ route('users.store') }}" method="POST">
                            @csrf

                            <div class="form-group mt-2">
                                <label for="name" class="form-label">Name</label>
                                <input type="text" id="name" name="name" class="form-control @error('name') is-invalid @enderror" value="{{ old('name') }}">
                            </div>

                            <div class="form-group mt-2">
                                <label for="email" class="form-label">Email</label>
                                <input type="email" id="email" name="email" class="form-control @error('email') is-invalid @enderror" value="{{ old('email') }}">
                            </div>

                            <div class="form-group mt-2">
                                <label for="role_id" class="form-label">Role</label>
                                <select
                                    id="role_id"
                                    name="role_id"
                                    class="form-select @error('role_id') is-invalid @enderror">
                                    <option value="" selected>Select a role...</option>
                                    @foreach ($roles as $role)
                                        <option value="{{ $role->id }}" {{ old('role_id') == $role->id ? 'selected' : ''}}>
                                            {{ $role->name }}
                                        </option>
                                    @endforeach
                                </select>
                            </div>

                            <div class="form-group mt-3">
                                <div class="d-flex justify-content-end">
                                    <a href="{{ route('tasks.index') }}" class="btn btn-outline-info mx-2">Cancel</a>
                                    <input type="submit" class="btn btn-success fw-semibold text-white text-capitalize" value="Submit">
                                </div>
                            </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/users/edit.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">
                    <h1 class="card-title text-capitalize">
                        {{ $user->name }}'s account
                    </h1>
                </div>

                <div class="card-body">
                    <x-errors :errors="$errors" />

                    <form action="{{ route('users.update', $user)}}" method="POST">
                        @csrf
                        @method('PUT')

                        <div class="form-group">
                            <label for="name" class="form-label">Name</label>
                            <input 
                                type="text" 
                                id="name" 
                                name="name" 
                                class="form-control @error('name') is-invalid @enderror" 
                                value="{{ old('name', $user->name) }}"
                                required>
                        </div>

                        <div class="form-group mt-2">
                            <label for="email" class="form-label">Email</label>
                            <input 
                                type="email" 
                                id="email" 
                                name="email" 
                                class="form-control @error('email') is-invalid @enderror" 
                                value="{{ old('email', $user->email) }}"
                                required>
                        </div>

                        <div class="form-group mt-2">
                            <label for="role_id" class="form-label">Role</label>
                            <select 
                                id="role_id" 
                                name="role_id" 
                                class="form-select @error('role_id') is-invalid @enderror" 
                                @if($user->hasRole('super-admin')) disabled @endif
                                required>
                                @if($user->roles->isEmpty())
                                    <option value="" selected>Select a role...</option>
                                @endif
                                @foreach($roles as $role)     
                                    <option value="{{ $role->id }}" {{ old('role_id', $user->roles)->contains($role->id) ? 'selected' : '' }}>
                                        {{ $role->name }}
                                    </option>
                                @endforeach
                            </select>
                        </div>

                        <div class="form-group mt-3">
                            <div class="d-flex justify-content-end ">
                                <a href="{{ route('users.index') }}" class="btn btn-outline-info me-2">Cancel</a>
                                <input type="submit" class="btn btn-success text-white text-capitalize" value="Update account">
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/users/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <x-flash-success :message="session('success')"/>

                <div class="card">
                    <div class="card-header">
                        <div class="row align-items-center mb-2">
                            <div class="col-md-4">
                                <h1 class="card-title ms-2">Users</h1>
                            </div>

                            <div class="col-md-4">
                                <x-search :action="route('users.index')" :search="$search" placeholder="Search for name or email"/>
                            </div>

                            <div class="col-md-4">
                                <div class="d-flex justify-content-end me-2">
                                    @can('create_user')
                                        <a href="{{ route('users.create') }}" class="btn btn-success text-white fw-semibold rounded me-2 text-capitalize">
                                            New user
                                        </a>
                                    @endcan
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="card-body">
                        <div class="mb-2 ms-2">
                            <table class="table table-responive-sm table-striped table-hover">
                                <thead>
                                <tr>
                                    <th>Name</th>
                                    <th>Email</th>
                                    <th>Role</th>
                                    @if (auth()->user()->can('edit_user') || auth()->user()->can('delete_user'))
                                        <th>Actions</th>
                                    @endif
                                </tr>
                                </thead>
                                <tbody>
                                @foreach ($users as $user)
                                    @if ((auth()->user()->hasRole('super-admin') &&
                                        $user->hasRole('super-admin')) ||
                                        !$user->hasRole('super-admin'))
                                        <tr>
                                            <td>
                                                <a href="{{ route('users.show', $user) }}" class="text-reset text-decoration-none">
                                                    {{ $user->name }}
                                                </a>
                                            </td>
                                            <td>{{ $user->email }}</td>
                                            <td>
                                                @forelse ($user->roles as $role)
                                                    {{ $role->name }}
                                                @empty
                                                    Null
                                                @endforelse
                                            </td>

                                            @if( auth()->user()->can('edit_user') || auth()->user()->can('delete_user'))
                                                <td class="d-flex justify-content-start align-items-center">
                                                    @can('edit_user')
                                                        <a href="{{ route('users.edit', $user) }}"
                                                           class="btn btn-sm btn-info fw-semibold text-capitalize">
                                                            edit
                                                        </a>
                                                    @endcan

                                                    @if (auth()->user()->can('delete_user') && !$user->hasRole('super-admin'))
                                                        <form action="{{ route('users.destroy', $user) }}" method="POST" onsubmit="return confirm('Are you sure you want to delete this user?');">
                                                            @csrf
                                                            @method('DELETE')

                                                            <input type="submit" class="btn btn-sm btn-danger text-white fw-semibold ms-2 text-capitalize" value="delete">
                                                        </form>
                                                    @endif
                                                </td>
                                            @endif
                                        </tr>
                                    @endif
                                @endforeach
                                </tbody>
                            </table>

                            <div class="d-flex justify-content-between align-items-center clearfix">
                                <div>
                                    {{ $users->count() .' of '. $users->total() .' users' }}
                                </div>
                                <div class="justify-content-center align-items-center">
                                    {{ $users->links() }}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/users/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="col-md-12">
            <x-flash-success :message="session('success')" />
            <x-errors :errors="$errors" />

            <div class="card">
                <div class="card-body">
                    <div class="d-flex justify-content-between align-items-center">
                        <h1 class="card-title ms-2">{{ $user->name }}</h1>
                    </div>

                    <div class="mb-2 ms-2">
                        <h2 class="card-subtitle mb-2">Details</h2>
                        <table>
                            <tr>
                                <td class="fw-bold">Email</td>
                                <td class="ps-2">{{ $user->email }}</td>
                            </tr>
                            <tr>
                                <td class="fw-bold">Role</td>
                                <td class="ps-2">{{ $user->roles[0]['name'] }}</td>
                            </tr>
                            <tr>
                                <td class="fw-bold">Account activated</td>
                                <td class="ps-2">{{  $user->password_changed_at ? 'Yes' : 'No' }}</td>
                            </tr>

                            @if($user->has_requested_new_token)
                                <td class="fw-bold">New token requested</td>
                                <td class="ps-2">{{ $user->new_token_requested_at->format('D d-M-Y H:i:s') }}</td>
                            @endif

                            @if($user->token_reset_at)
                                <td class="fw-bold">New token sent at</td>
                                <td class="ps-2">{{ $user->token_reset_at->format('D d-M-Y H:i') }}</td>
                            @endif
                        </table>
                    </div>

                    @if($user->has_requested_new_token)
                        <div class="mt-5">
                            <form action="{{ route('users.new-token', $user) }}" method="POST">
                                @csrf
                                <button class="btn btn-primary text-white fw-semibold btn-block">Grant new token</button>
                            </form>
                        </div>
                    @endif
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/users/trashed.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <x-flash-success :message="session('success')" />
                <x-alert-danger :message="session('danger')" />

                <div class="card">
                    <div class="card-header">
                        <h1 class="card-title">
                            Trashed users
                        </h1>
                    </div>

                    <div class="card-body">
                        <div class="mb-2 ms-2">
                            @if(!$users->count())
                                <p>No trashed users yet</p>
                            @else
                                <table class="table table-responsive-sm table-striped table-hover">
                                    <thead>
                                        <tr>
                                            <th>Name</th>
                                            <th>E-mail</th>
                                            <th>Deleted at</th>
                                            @if(auth()->user()->can('restore_user'))
                                                <th>Actions</th>
                                            @endif
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($users as $user)
                                            <tr class="align-items-center">
                                                <td>{{ $user->name }}</td>
                                                <td>{{ $user->email }}</td>
                                                <td>{{ $user->deleted_at->format('d M Y') }}</td>
                                                
                                                @can('restore_user')
                                                    <td>
                                                        <form action="{{ route('users.restore', $user) }}" method="POST">
                                                            @csrf
                                                            @method('PATCH')
                                                            <input type="submit" class="btn btn-sm btn-info text-white fw-semibold" value="Restore">
                                                        </form>
                                                    </td>
                                                @endcan
                                            </tr>
                                        @endforeach
                                    </tbody>
                                </table>

                                <div class="d-flex justify-content-center">
                                    {{ $users->links() }}
                                </div>
                            @endif
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection